#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include <netdnet/dn.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/types.h>

struct	sockaddr_dn		sockaddr;
char				nodename[20],ibuf[4096];
int				sockfd,insock,len,readnum;
struct	optdata_dn		optdata;
/*-----------------------------------------------------------------------*/
int main(int argc, char *argv[])
{
	pid_t	pid;

	if (getuid() != 0)
	{
		perror("Must be root to run dnmirror daemon");
		exit(2);
	}
#ifndef NO_FORK
	switch(pid=fork())
	{
		case -1 : perror("dnmirror cannot fork");
			  exit(2);
		case  0 : setsid();
			  close(0); close(1); close(2);
			  chdir("/");
			  break;
		default : exit(0);
	}
#endif
  	if ((sockfd=socket(AF_DECnet,SOCK_SEQPACKET,DNPROTO_NSP)) == -1) 
	{
    		perror("socket");
    		exit(-1);
  	}
	optdata.opt_sts=0x00;
	optdata.opt_optl=0x02;		/* two bytes for optdata */
	optdata.opt_data[0]=0x00;
	optdata.opt_data[1]=0x10;	/* We can loopback up to 4096 bytes */

  	if ((setsockopt(sockfd,DNPROTO_NSP,SO_CONDATA,&optdata,sizeof(optdata))) < 0) 
	{
		perror("setsockopt");
		exit(-1);
	}

	sockaddr.sdn_family = AF_DECnet;
	sockaddr.sdn_flags	= 0x00;
	sockaddr.sdn_objnum	= 0x19;			/* MIRROR */
	sockaddr.sdn_objnamel	= 0x00;

	if (bind(sockfd, (struct sockaddr *)&sockaddr, 
		sizeof(sockaddr)) < 0) 
	{
		perror("Bind");
		exit(-1);
	}

	if (listen(sockfd,1) < 0)
	{
		perror("Listen");
		exit(-1);
	}
	for (;;)
	{
	  if ( (insock=accept(sockfd, (struct sockaddr *)&sockaddr, &len)) < 0)
	  {
		perror("Accept");
		exit(-1);
	  }
	
	  while ( (readnum=read(insock,ibuf,sizeof(ibuf))) > 0)
	  {
		ibuf[0]=0x01;
		if (write(insock,ibuf,readnum) < 0)
		{
			perror("Write");
			exit(-1);
		}
	  }
	  close(insock);
	}
	close(sockfd);
	return 0;
}
/*-------------------------------------------------------------------------*/
