/******************************************************************************
    (c) 1998 P.J. Caulfield               patrick@pandh.demon.co.uk
                                          pcaulfield@cix.co.uk
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 ******************************************************************************
 */
/* Header file to cope with endian issues */

#if (__BYTE_ORDER == 1234)

/* DECnet is little-endian so these are no-ops */
#define dn_ntohs(x) (x)
#define dn_htons(x) (x)

#define dn_ntohl(x) (x)
#define dn_htonl(x) (x)

#else

#define dn_ntohs(x) (((x)&0x0ff)<<8) | (((x)&0xff00)>>8)

#define dn_ntohl(x) (((x)&0x00ff)<<8) | (((x)&0xff00)>>8) | (((x)&0x000000ff)<<8) | (((x)&0xff000000)>>8)

#define dn_htonl(x) dn_ntohl(x)
#define dn_htons(x) dn_ntohs(x)
#endif
